"
 COPYRIGHT (c) 1997 by eXept Software AG / Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"





ToolApplicationModel subclass:#DataSetBuilder
	instanceVariableNames:'className superclassName hasChanged columnView columns
		selectedColumnIndex tabSelectionIndex aspects'
	classVariableNames:'Number'
	poolDictionaries:''
	category:'Interface-UIPainter'
!

!DataSetBuilder class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG / Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"




!

documentation
"
    create and modify or inspect dataset columns; used by UIPainter (DataSetColumnSpec)

    [see also:]
        DataSetColumnSpec
        DataSetSpec
        DataSetView
        DataSetColumn

    [author:]
        Claus Atzkern, eXept Software AG
"

! !

!DataSetBuilder class methodsFor:'help specs'!

helpSpec
    "return a dictionary filled with helpKey -> helptext associations.
     These are used by the activeHelp tool."

    "
    UIHelpTool openOnClass:DataSetBuilder    
    "

  ^ super helpSpec addPairsFrom:#(

#addColumn
'Adds a new column.'

#backgroundColor
'Sets the background color of the column if the color-checkBox is turned on. Otherwise, the column uses its default background color (which is specified in the styleSheet).'

#backgroundSelector
'Selector which returns the background color for a cell (optional). If the selector is nil or returns nil, the default background color is set.'

#canSelect
'If true, each cell in the column can be selected. In case of having a menu, the menu can be opened by selecting the cell and pressing down the right or middle button of the mouse. if false, the whole line is selected. The menu opened derives from the DataSetView, which is specified in the window specification (Basics).'

#choices
'Selector to get the collection of choices for a column which is selectable and its editor is kind of a ComboBox or ComboList. If a cell in the column is selected, the visual editor is opened and in case of having choices, the choices are assigned to the widget.'

#doubleClickedSelector
'Selector evaluated without arguments on selected column.'

#editorField
'Type of visual editor (using default editors) or a selector, which will return an visual editor. If the cell is selected, a visual editor is opened in in the cell. In case of an unsupported selector (user defined editor), the row object is asked for the visual editor by performing the selector on the row. A widget instance must be returned which is opened in the cell.'

#foregroundColor
'Sets the foreground color of the column  if the color-checkBox is turned on. Otherwise, the column uses its default foreground color (which is specified in the styleSheet).'

#foregroundSelector
'Selector which returns the foreground color for a cell (optional). If the selector is nil or returns nil, the default foreground color is set.'

#formatString
'Format string, which specifies the output format of a text in a cell. At the moment  only numbers are supported  (for example: 0.0000).'

#height
'Preferred height (optional).'

#label
'The label of the column. If ''label is image'' is off, this is the label string. Otherwise, it specifies the applications selector, which returns the label - either a string or a bitmap image.'

#labelIsImage
'If ''label is image'' is off (the default), the columns label is the string as entered in the label aspect. Otherwise, its the name of the message sent to the application - this should return a string or bitmap image, which is used as logo in the column.'

#menuSelector
'A selector to access the middleButton menu or nil. If a cell is selected. The menu will be opened by selecting the cell and pressing down the right or middle button of the mouse.'

#minWidth
'Makes sense if the width is set to 0 or nil. This is the minimum size required; no computation dependent on the contents. When resizing the view the column may grow or shrink to the minimum width.'

#printSelector
'A selector with one argument, the DataSetView. Used to access a drawable display object. In case of nil, the value derived from the readSelector is shown in the unselected cell.\ \ Using bitmaps, the DataSetView offers three important methods:\ \ #registerImage:anImage key:aSymbol\ register an image with an unique symbol. This symbol can be used by the row object to access the image, using #registeredImageAt:. The image will be associated to the device.\ \ #registeredImageAt:aSymbol\ returns an image assigned to the symbol or nil. The image returned is associated to the device.\ \ #releaseAllRegisteredImages\ relaese all registered images.'

#readSelector
'A selector, which is used to get or set (if the write selector is undefined) the value of a cell. The value returned by the method can be a string object or a bitmap. The set operation only is performed if the column is selectable.'

#rendererType
'This type specifies, how the text of an unselected cell should be shown. As Text, CheckToggle, ComboBox, ComboList or as a RowSelector.'

#selectSelector
'An optional selector, which is used to test whether the cell in the column is selectable; the ''Is Selectable'' flag must be enabled.'

#showColumnSeparator
'Shows or hide the column separator (right vertical separator).'

#showRowSeparator
'Shows or hide the row separator (bottom horizontal separator).'

#size
'Max size of an InputField, ComboBox or ComboList. 0 or nil means unlimited.'

#type
'A type converter symbol used by the input field.'

#width
'The width of a fixed column; in case of nil or 0 the column width will be computed dependent on the contents.'

#writeSelector
'A selector, which is used to set the value of a cell. If the selector is not defined, the selector derives from the printSelector.'

)
! !

!DataSetBuilder class methodsFor:'interface specs'!

basicsEditSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#basicsEditSpec
     DataSetBuilder new openInterface:#basicsEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'DataSet Basic'
              #'layout:' #(#LayoutFrame 330 0 352 0 618 0 607 0)
              #'label:' 'DataSet Basic'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1280 1024)
              #'bounds:' #(#Rectangle 330 352 619 608)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'framedBox1'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0 0 1.0 145 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'label1'
                              #'layout:' #(#AlignmentOrigin 107 0 32 0 1 0.5)
                              #'label:' 'Label:'
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'labelField'
                              #'layout:' #(#LayoutFrame 110 0 21 0 15 1.0 43 0)
                              #'activeHelpKey:' #label
                              #'tabable:' true
                              #'model:' #label
                          )
                           #(#CheckBoxSpec
                              #'name:' 'labelIsImage'
                              #'layout:' #(#LayoutOrigin 107 0 103 0)
                              #'activeHelpKey:' #labelIsImage
                              #'tabable:' true
                              #'model:' #labelIsImage
                              #'label:' 'Label Is Image'
                          )
                           #(#UISubSpecification
                              #'name:' 'fontSubSpec'
                              #'layout:' #(#LayoutFrame 60 0.0 47 0 15 1.0 72 0)
                              #'minorKey:' #fontSpec
                          )
                           #(#PopUpListSpec
                              #'name:' 'Alignment'
                              #'layout:' #(#LayoutFrame 110 0 78 0 15 1.0 100 0)
                              #'label:' 'Alignment'
                              #'model:' #labelAlignment
                              #'menu:' 
                               #(#left
                                  #right #center
                              )
                              #'useIndex:' false
                          )
                           #(#LabelSpec
                              #'name:' 'JustificationLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 89 0 1 0.5)
                              #'label:' 'Justification:'
                              #'adjust:' #left
                              #'resizeForLabel:' true
                          )
                        )
                    )
                    #'label:' 'Header:'
                    #'labelPosition:' #topLeft
                )
                 #(#FramedBoxSpec
                    #'name:' 'typesFrame'
                    #'layout:' #(#LayoutFrame 0 0.0 145 0 0 1.0 227 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'rendererLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 29 0 1 0.5)
                              #'label:' 'Renderer:'
                              #'resizeForLabel:' true
                          )
                           #(#ComboListSpec
                              #'name:' 'rendererField'
                              #'layout:' #(#LayoutFrame 110 0 18 0 15 1.0 40 0)
                              #'activeHelpKey:' #rendererType
                              #'tabable:' true
                              #'model:' #rendererType
                              #'comboList:' #rendererTypeList
                              #'useIndex:' false
                          )
                           #(#LabelSpec
                              #'name:' 'editorLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 55 0 1 0.5)
                              #'label:' 'Editor:'
                              #'resizeForLabel:' true
                          )
                           #(#ComboBoxSpec
                              #'name:' 'editorField'
                              #'layout:' #(#LayoutFrame 110 0 44 0 15 1.0 66 0)
                              #'activeHelpKey:' #editorField
                              #'tabable:' true
                              #'model:' #editorType
                              #'type:' #symbolOrNil
                              #'comboList:' #editorTypeList
                              #'useIndex:' false
                          )
                        )
                    )
                    #'label:' 'Cell Type:'
                    #'labelPosition:' #topLeft
                )
              )
          )
      )
!

colorsEditSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#colorsEditSpec
     DataSetBuilder new openInterface:#colorsEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'DataSet Misc'
              #'layout:' #(#LayoutFrame 197 0 172 0 565 0 471 0)
              #'label:' 'DataSet Misc'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1280 1024)
              #'bounds:' #(#Rectangle 197 172 566 472)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'ColorsBox'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0 0 1.0 88 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'label1'
                              #'layout:' #(#AlignmentOrigin 107 0 27 0 1 0.5)
                              #'label:' 'Foreground:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#ColorMenuSpec
                              #'name:' 'colorMenu1'
                              #'layout:' #(#LayoutFrame 110 0 15 0 12 1.0 37 0)
                              #'activeHelpKey:' #foregroundColor
                              #'model:' #labelForegroundColor
                              #'labelsAreColored:' true
                          )
                           #(#LabelSpec
                              #'name:' 'label2'
                              #'layout:' #(#AlignmentOrigin 107 0 55 0 1 0.5)
                              #'label:' 'Background:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#ColorMenuSpec
                              #'name:' 'colorMenu2'
                              #'layout:' #(#LayoutFrame 110 0 43 0 12 1.0 65 0)
                              #'activeHelpKey:' #backgroundColor
                              #'model:' #labelBackgroundColor
                          )
                        )
                    )
                    #'label:' 'Label Colors:'
                    #'labelPosition:' #topLeft
                )
                 #(#FramedBoxSpec
                    #'name:' 'defaultColorsBox'
                    #'layout:' #(#LayoutFrame 0 0.0 88 0 0 1.0 230 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'fgLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 27 0 1 0.5)
                              #'label:' 'Foreground:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#ColorMenuSpec
                              #'name:' 'fgMenu'
                              #'layout:' #(#LayoutFrame 110 0 15 0 12 1.0 37 0)
                              #'activeHelpKey:' #foregroundColor
                              #'model:' #foregroundColor
                              #'labelsAreColored:' true
                          )
                           #(#LabelSpec
                              #'name:' 'bgLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 55 0 1 0.5)
                              #'label:' 'Background:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#ColorMenuSpec
                              #'name:' 'bgMenu'
                              #'layout:' #(#LayoutFrame 110 0 43 0 12 1.0 65 0)
                              #'activeHelpKey:' #backgroundColor
                              #'model:' #backgroundColor
                          )
                           #(#LabelSpec
                              #'name:' 'fgSelLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 89 0 1 0.5)
                              #'label:' 'FG-Selector:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'fgSelField'
                              #'layout:' #(#LayoutFrame 110 0 78 0 15 1.0 100 0)
                              #'activeHelpKey:' #foregroundSelector
                              #'tabable:' true
                              #'model:' #foregroundSelector
                              #'type:' #symbolOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'bgSelLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 114 0 1 0.5)
                              #'label:' 'BG-Selector:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'bgSelField'
                              #'layout:' #(#LayoutFrame 110 0 103 0 15 1.0 125 0)
                              #'activeHelpKey:' #backgroundSelector
                              #'tabable:' true
                              #'model:' #backgroundSelector
                              #'type:' #symbolOrNil
                          )
                        )
                    )
                    #'label:' 'Cell Colors:'
                    #'labelPosition:' #topLeft
                )
              )
          )
      )
!

defineClassNameSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#defineClassNameSpec
     DataSetBuilder new openInterface:#defineClassNameSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'Data Set Builder'
              #'layout:' #(#LayoutFrame 185 0 408 0 511 0 543 0)
              #'label:' 'Data Set Builder'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1152 900)
              #'bounds:' #(#Rectangle 185 408 512 544)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'framedBox1'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0.0 0 1.0 -34 1.0)
                    #'label:' 'Classes for code'
                    #'labelPosition:' #topLeft
                )
                 #(#LabelSpec
                    #'name:' 'classLabel'
                    #'layout:' #(#AlignmentOrigin 73 0.11 38 0 1 0.5)
                    #'label:' 'Class:'
                    #'adjust:' #right
                    #'resizeForLabel:' true
                )
                 #(#InputFieldSpec
                    #'name:' 'classNameInputField'
                    #'layout:' #(#LayoutFrame 77 0.11 27 0 -16 1.0 49 0)
                    #'tabable:' true
                    #'model:' #classNameChannel
                )
                 #(#LabelSpec
                    #'name:' 'superClassLabel'
                    #'layout:' #(#AlignmentOrigin 73 0.11 65 0 1 0.5)
                    #'label:' 'Superclass:'
                    #'adjust:' #right
                    #'resizeForLabel:' true
                )
                 #(#InputFieldSpec
                    #'name:' 'superclassNameInputField'
                    #'layout:' #(#LayoutFrame 76 0.11 55 0 -16 1.0 77 0)
                    #'tabable:' true
                    #'model:' #superclassNameChannel
                )
                 #(#UISubSpecification
                    #'name:' 'SubSpecification'
                    #'layout:' #(#LayoutFrame 0 0.0 -29 1 0 1.0 -5 1.0)
                    #'majorKey:' #ToolApplicationModel
                    #'minorKey:' #windowSpecForCommitWithoutChannels
                )
              )
          )
      )
!

formatEditSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#formatEditSpec
     DataSetBuilder new openInterface:#formatEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'DataSet Details'
              #'layout:' #(#LayoutFrame 319 0 352 0 706 0 643 0)
              #'label:' 'DataSet Details'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1280 1024)
              #'bounds:' #(#Rectangle 319 352 707 644)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'framedBox1'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0 0 1.0 114 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'typeLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 29 0 1 0.5)
                              #'label:' 'Input Type:'
                              #'resizeForLabel:' true
                          )
                           #(#ComboListSpec
                              #'name:' 'typeCombo'
                              #'layout:' #(#LayoutFrame 110 0 18 0 15 1.0 40 0)
                              #'activeHelpKey:' #type
                              #'tabable:' true
                              #'model:' #type
                              #'comboList:' 
                               #(#string
                                  #password #number
                                  #numberOrNil #symbolOrNil
                              )
                              #'useIndex:' false
                          )
                           #(#LabelSpec
                              #'name:' 'sizeLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 55 0 1 0.5)
                              #'label:' 'Max Size:'
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'sizeField'
                              #'layout:' #(#LayoutFrame 110 0 44 0 15 1.0 66 0)
                              #'activeHelpKey:' #size
                              #'tabable:' true
                              #'model:' #size
                              #'type:' #numberOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'formatLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 80 0 1 0.5)
                              #'label:' 'Text Format:'
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'formatField'
                              #'layout:' #(#LayoutFrame 110 0 69 0 15 1.0 91 0)
                              #'activeHelpKey:' #formatString
                              #'tabable:' true
                              #'model:' #formatString
                          )
                        )
                    )
                    #'label:' 'Input Format'
                    #'labelPosition:' #topLeft
                )
              )
          )
      )
!

frameEditSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#frameEditSpec
     DataSetBuilder new openInterface:#frameEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'DataSet Dimension'
              #'layout:' #(#LayoutFrame 381 0 370 0 671 0 583 0)
              #'label:' 'DataSet Dimension'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1280 1024)
              #'bounds:' #(#Rectangle 381 370 672 584)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'separatorBox'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0 0 1.0 86 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#CheckBoxSpec
                              #'name:' 'showRowSeparator'
                              #'layout:' #(#LayoutFrame 18 0 19 0 194 0 42 0)
                              #'activeHelpKey:' #showRowSeparator
                              #'tabable:' true
                              #'model:' #showRowSeparator
                              #'label:' 'Show Row-Separator'
                          )
                           #(#CheckBoxSpec
                              #'name:' 'showColSeparator'
                              #'layout:' #(#LayoutFrame 18 0 45 0 194 0 68 0)
                              #'activeHelpKey:' #showColumnSeparator
                              #'tabable:' true
                              #'model:' #showColSeparator
                              #'label:' 'Show Column-Separator'
                          )
                        )
                    )
                    #'label:' 'Separators'
                    #'labelPosition:' #topLeft
                )
                 #(#FramedBoxSpec
                    #'name:' 'framedBox1'
                    #'layout:' #(#LayoutFrame 0 0.0 86 0 0 1.0 198 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'widthLabel'
                              #'layout:' #(#AlignmentOrigin 107 0.0 28 0 1 0.5)
                              #'label:' 'Column Width:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'widthField'
                              #'layout:' #(#LayoutFrame 110 0 17 0 15 1.0 39 0)
                              #'activeHelpKey:' #width
                              #'tabable:' true
                              #'model:' #width
                              #'type:' #numberOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'minWidthLabel'
                              #'layout:' #(#AlignmentOrigin 107 0.0 53 0 1 0.5)
                              #'label:' 'Min Width:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'minWidthField'
                              #'layout:' #(#LayoutFrame 110 0 42 0 15 1.0 64 0)
                              #'activeHelpKey:' #minWidth
                              #'tabable:' true
                              #'model:' #minWidth
                              #'type:' #numberOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'heightLabel'
                              #'layout:' #(#AlignmentOrigin 107 0.0 84 0 1 0.5)
                              #'label:' 'Row Height:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'heightField'
                              #'layout:' #(#LayoutFrame 110 0 73 0 15 1.0 95 0)
                              #'activeHelpKey:' #height
                              #'tabable:' true
                              #'model:' #height
                              #'type:' #numberOrNil
                          )
                        )
                    )
                    #'label:' 'Dimensions:'
                    #'labelPosition:' #topLeft
                )
              )
          )
      )
!

selectionEditSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#selectionEditSpec
     DataSetBuilder new openInterface:#selectionEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'DataSet Basic'
              #'layout:' #(#LayoutFrame 296 0 284 0 584 0 539 0)
              #'label:' 'DataSet Basic'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1280 1024)
              #'bounds:' #(#Rectangle 296 284 585 540)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'framedBox2'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0 0 1.0 85 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'ActionLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 28 0 1 0.5)
                              #'label:' 'Selector:'
                              #'adjust:' #left
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'ActionSelector'
                              #'layout:' #(#LayoutFrame 110 0 17 0 15 1.0 39 0)
                              #'tabable:' true
                              #'model:' #labelActionSelector
                              #'type:' #symbolOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'ArgumentLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 53 0 1 0.5)
                              #'label:' 'Argument:'
                              #'adjust:' #left
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'ArgumentValue'
                              #'layout:' #(#LayoutFrame 110 0 42 0 15 1.0 64 0)
                              #'tabable:' true
                              #'model:' #labelActionArgument
                              #'type:' #string
                          )
                        )
                    )
                    #'label:' 'Label Select Action:'
                    #'labelPosition:' #topLeft
                )
                 #(#FramedBoxSpec
                    #'name:' 'framedBox1'
                    #'layout:' #(#LayoutFrame 0 0.0 85 0 0 1.0 166 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#CheckBoxSpec
                              #'name:' 'canSelect'
                              #'layout:' #(#Point 107 17)
                              #'activeHelpKey:' #canSelect
                              #'tabable:' true
                              #'model:' #canSelect
                              #'label:' 'Is Selectable'
                          )
                           #(#LabelSpec
                              #'name:' 'selectorLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 53 0 1 0.5)
                              #'label:' 'Selector:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'selectSelector'
                              #'layout:' #(#LayoutFrame 110 0 42 0 15 1.0 64 0)
                              #'activeHelpKey:' #selectSelector
                              #'tabable:' true
                              #'model:' #selectSelector
                              #'type:' #symbolOrNil
                          )
                        )
                    )
                    #'label:' 'Cell Selection:'
                    #'labelPosition:' #topLeft
                )
                 #(#FramedBoxSpec
                    #'name:' 'framedBox3'
                    #'layout:' #(#LayoutFrame 0 0.0 166 0 0 1.0 220 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'doubleLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 27 0 1 0.5)
                              #'label:' 'Selector:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'doubleClicked'
                              #'layout:' #(#LayoutFrame 110 0 16 0 15 1.0 38 0)
                              #'activeHelpKey:' #doubleClickedSelector
                              #'tabable:' true
                              #'model:' #doubleClickedSelector
                              #'type:' #symbolOrNil
                          )
                        )
                    )
                    #'label:' 'Cell Double Click:'
                    #'labelPosition:' #topLeft
                )
              )
          )
      )
!

slices
    ^#(
        (Basics         basicsEditSpec)
        (Values         valuesEditSpec)
        (Format         formatEditSpec)
        (Selection      selectionEditSpec)
        (Frame          frameEditSpec)
        (Colors         colorsEditSpec)
    )
!

valuesEditSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#valuesEditSpec
     DataSetBuilder new openInterface:#valuesEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'DataSet Basic'
              #'layout:' #(#LayoutFrame 364 0 378 0 659 0 683 0)
              #'label:' 'DataSet Basic'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1280 1024)
              #'bounds:' #(#Rectangle 364 378 660 684)
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#FramedBoxSpec
                    #'name:' 'valuesBox'
                    #'layout:' #(#LayoutFrame 0 0.0 3 0 0 1.0 107 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'readLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 29 0 1 0.5)
                              #'label:' 'Read:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'readSelector'
                              #'layout:' #(#LayoutFrame 110 0 18 0 15 1.0 40 0)
                              #'activeHelpKey:' #readSelector
                              #'tabable:' true
                              #'model:' #readSelector
                              #'type:' #symbolOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'writeLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 54 0 1 0.5)
                              #'label:' 'Write:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'writeSelector'
                              #'layout:' #(#LayoutFrame 110 0 43 0 15 1.0 63 0)
                              #'activeHelpKey:' #writeSelector
                              #'tabable:' true
                              #'model:' #writeSelector
                              #'type:' #symbolOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'printLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 77 0 1 0.5)
                              #'label:' 'Print:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'printSelector'
                              #'layout:' #(#LayoutFrame 110 0 66 0 15 1.0 86 0)
                              #'activeHelpKey:' #printSelector
                              #'tabable:' true
                              #'model:' #printSelector
                              #'type:' #symbolOrNil
                          )
                        )
                    )
                    #'label:' 'Value Selectors:'
                    #'labelPosition:' #topLeft
                )
                 #(#FramedBoxSpec
                    #'name:' 'menusBox'
                    #'layout:' #(#LayoutFrame 0 0.0 107 0 0 1.0 186 0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#LabelSpec
                              #'name:' 'menuLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 29 0 1 0.5)
                              #'label:' 'Menu:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'menuSelector'
                              #'layout:' #(#LayoutFrame 110 0 18 0 15 1.0 38 0)
                              #'activeHelpKey:' #menuSelector
                              #'tabable:' true
                              #'model:' #menu
                              #'type:' #symbolOrNil
                          )
                           #(#LabelSpec
                              #'name:' 'choicesLabel'
                              #'layout:' #(#AlignmentOrigin 107 0 52 0 1 0.5)
                              #'label:' 'Choice:'
                              #'adjust:' #right
                              #'resizeForLabel:' true
                          )
                           #(#InputFieldSpec
                              #'name:' 'choicesSelector'
                              #'layout:' #(#LayoutFrame 110 0 41 0 15 1.0 61 0)
                              #'activeHelpKey:' #choices
                              #'tabable:' true
                              #'model:' #choices
                              #'type:' #symbolOrNil
                          )
                        )
                    )
                    #'label:' 'Menu Selectors:'
                    #'labelPosition:' #topLeft
                )
              )
          )
      )
!

windowSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:DataSetBuilder andSelector:#windowSpec
     DataSetBuilder new openInterface:#windowSpec
    "
    "DataSetBuilder open"

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'Data Set Builder'
              #'layout:' #(#LayoutFrame 323 0 352 0 809 0 711 0)
              #'label:' 'Data Set Builder'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1152 900)
              #'bounds:' #(#Rectangle 323 352 810 712)
              #'menu:' #menu
              #'usePreferredExtent:' false
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#MenuPanelSpec
                    #'name:' 'menuToolbarView'
                    #'layout:' #(#LayoutFrame 0 0.0 0 0.0 0 1.0 32 0)
                    #'menu:' #menuToolbar
                )
                 #(#VariableHorizontalPanelSpec
                    #'name:' 'VariablePanel'
                    #'layout:' #(#LayoutFrame 0 0.0 34 0.0 0 1.0 -22 1.0)
                    #'component:' 
                     #(#SpecCollection
                        #'collection:' 
                         #(
                           #(#ViewSpec
                              #'name:' 'labelsView'
                              #'component:' 
                               #(#SpecCollection
                                  #'collection:' 
                                   #(
                                     #(#SequenceViewSpec
                                        #'name:' 'columnView'
                                        #'layout:' #(#LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0)
                                        #'model:' #selectedColumnModel
                                        #'menu:' #menuEdit
                                        #'hasHorizontalScrollBar:' true
                                        #'hasVerticalScrollBar:' true
                                        #'miniScrollerHorizontal:' true
                                        #'useIndex:' true
                                        #'sequenceList:' #seqList
                                    )
                                  )
                              )
                          )
                           #(#ViewSpec
                              #'name:' 'specView'
                              #'component:' 
                               #(#SpecCollection
                                  #'collection:' 
                                   #(
                                     #(#TabViewSpec
                                        #'name:' 'tabView'
                                        #'layout:' #(#LayoutFrame 0 0.0 0 0 0 1.0 35 0)
                                        #'model:' #tabModel
                                        #'menu:' #tabList
                                        #'useIndex:' true
                                    )
                                     #(#SubCanvasSpec
                                        #'name:' 'specCanvas'
                                        #'layout:' #(#LayoutFrame 0 0.0 35 0.0 0 1.0 -30 1.0)
                                        #'specHolder:' #specChannel
                                    )
                                     #(#UISubSpecification
                                        #'name:' 'SubSpecification'
                                        #'layout:' #(#LayoutFrame 2 0.0 -26 1 -2 1.0 -2 1.0)
                                        #'majorKey:' #ToolApplicationModel
                                        #'minorKey:' #windowSpecForCommit
                                    )
                                  )
                              )
                              #'borderWidth:' 1
                          )
                        )
                    )
                    #'handles:' #(#Any 0.265905 1.0)
                )
                 #(#UISubSpecification
                    #'name:' 'infoBarSubSpec'
                    #'layout:' #(#LayoutFrame 0 0.0 -22 1 0 1.0 0 1.0)
                    #'majorKey:' #ToolApplicationModel
                    #'minorKey:' #windowSpecForInfoBar
                )
              )
          )
      )
! !

!DataSetBuilder class methodsFor:'menu specs'!

menu
    "this window spec was automatically generated by the ST/X MenuEditor"

    "do not manually edit this - the builder may not be able to
     handle the specification if its corrupted."

    "
     MenuEditor new openOnClass:DataSetBuilder andSelector:#menu
     (Menu new fromLiteralArrayEncoding:(DataSetBuilder menu)) startUp
    "

    <resource: #menu>

    ^
     
       #(#Menu
          
           #(
             #(#MenuItem
                #'label:' 'About'
                #'labelImage:' #(#ResourceRetriever nil #menuIcon)
                #'submenuChannel:' #menuAbout
            )
             #(#MenuItem
                #'label:' 'File'
                #'submenu:' 
                 #(#Menu
                    
                     #(
                       #(#MenuItem
                          #'label:' 'Generate Code'
                          #'value:' #doGenerateCode
                      )
                       #(#MenuItem
                          #'label:' '-'
                      )
                       #(#MenuItem
                          #'label:' 'Define DataSet Class...'
                          #'value:' #doDefineClass
                      )
                       #(#MenuItem
                          #'label:' 'Browse DataSet Class'
                          #'value:' #doBrowseClass
                      )
                       #(#MenuItem
                          #'label:' '-'
                      )
                       #(#MenuItem
                          #'label:' 'Exit'
                          #'value:' #closeRequest
                          #'activeHelpKey:' #fileExit
                      )
                    ) nil
                    nil
                )
            )
             #(#MenuItem
                #'label:' 'Edit'
                #'submenuChannel:' #menuEdit
            )
             #(#MenuItem
                #'label:' 'Add'
                #'submenu:' 
                 #(#Menu
                    
                     #(
                       #(#MenuItem
                          #'label:' 'Column'
                          #'value:' #doCreateColumn
                          #'activeHelpKey:' #addColumn
                          #'enabled:' #columnIsNotEditing
                          #'labelImage:' #(#ResourceRetriever nil #newColumnIcon 'Column')
                      )
                    ) nil
                    nil
                )
            )
             #(#MenuItem
                #'label:' 'Help'
                #'startGroup:' #right
                #'submenuChannel:' #menuHelp
            )
          ) nil
          nil
      )
!

menuEdit
    "this window spec was automatically generated by the ST/X MenuEditor"

    "do not manually edit this - the builder may not be able to
     handle the specification if its corrupted."

    "
     MenuEditor new openOnClass:DataSetBuilder andSelector:#menuEdit
     (Menu new fromLiteralArrayEncoding:(DataSetBuilder menuEdit)) startUp
    "

    <resource: #menu>

    ^
     
       #(#Menu
          
           #(
             #(#MenuItem
                #'label:' 'Cut'
                #'value:' #doCutColumn
                #'activeHelpKey:' #editCut
                #'enabled:' #isColumnSelected
            )
             #(#MenuItem
                #'label:' 'Copy'
                #'value:' #doCopyColumn
                #'activeHelpKey:' #editCopy
                #'enabled:' #isColumnSelected
            )
             #(#MenuItem
                #'label:' 'Paste'
                #'value:' #doPasteColumn
                #'activeHelpKey:' #editPaste
                #'enabled:' #valueOfHavingClipboard
            )
             #(#MenuItem
                #'label:' '-'
            )
             #(#MenuItem
                #'label:' 'Move Up'
                #'value:' #'doMoveColumn:'
                #'activeHelpKey:' #editMoveUp
                #'enabled:' #isColumnSelected
                #'argument:' #up
                #'labelImage:' #(#ResourceRetriever #DataSetBuilder #upIcon 'Move Up')
            )
             #(#MenuItem
                #'label:' 'Move Down'
                #'value:' #'doMoveColumn:'
                #'activeHelpKey:' #editMoveDown
                #'enabled:' #isColumnSelected
                #'argument:' #down
                #'labelImage:' #(#ResourceRetriever #DataSetBuilder #downIcon 'Move Down')
            )
          ) nil
          nil
      )
!

menuToolbar
    "this window spec was automatically generated by the ST/X MenuEditor"

    "do not manually edit this - the builder may not be able to
     handle the specification if its corrupted."

    "
     MenuEditor new openOnClass:DataSetBuilder andSelector:#menuToolbar
     (Menu new fromLiteralArrayEncoding:(DataSetBuilder menuToolbar)) startUp
    "

    <resource: #menu>

    ^
     
       #(#Menu
          
           #(
             #(#MenuItem
                #'label:' 'Add Column'
                #'isButton:' true
                #'value:' #doCreateColumn
                #'activeHelpKey:' #addColumn
                #'enabled:' #columnIsNotEditing
                #'labelImage:' #(#ResourceRetriever nil #newColumnIcon)
            )
             #(#MenuItem
                #'label:' ''
            )
             #(#MenuItem
                #'label:' 'Move Up'
                #'isButton:' true
                #'value:' #'doMoveColumn:'
                #'activeHelpKey:' #editMoveUp
                #'enabled:' #isColumnSelected
                #'argument:' #up
                #'labelImage:' #(#ResourceRetriever nil #upIcon)
            )
             #(#MenuItem
                #'label:' 'Move Down'
                #'isButton:' true
                #'value:' #'doMoveColumn:'
                #'activeHelpKey:' #editMoveDown
                #'enabled:' #isColumnSelected
                #'argument:' #down
                #'labelImage:' #(#ResourceRetriever nil #downIcon)
            )
          ) nil
          nil
      )
! !

!DataSetBuilder class methodsFor:'resources'!

newColumnIcon
    "Generated by the Image Editor"
    "
    ImageEditor openOnClass:self andSelector:#newColumnIcon
    "

    <resource: #image>

    ^Icon
        constantNamed:#'DataSetBuilder newColumnIcon'
        ifAbsentPut:[(Depth2Image new) width: 22; height: 22; photometric:(#palette); bitsPerSample:(#(2 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'UT@@@@UPUTUUUXUPUTZ**,UPUTZB",UPUTX*H,UYUTX*H,UPUTZB",UPQTZ**,UPUTX*H,UPUTX*H,UPUTX*H,UPUTXB@,UPUTZ**,UPUTZ**,UPUTX"H,UYUTXB@,UPUTX"@,UPUTX"H,UPUTZ**,UPUTZ**,UPUT/??<UPUT@@@@UP'); colorMap:(((Array new:4) at:1 put:((Color black)); at:2 put:((Color white)); at:3 put:((Color grey:66.9978)); at:4 put:((Color grey:49.9962)); yourself)); mask:((Depth1Image new) width: 22; height: 22; photometric:(#blackIs0); bitsPerSample:(#(1 )); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'A??@A??@A??@A??@A??@A??@A??@A??@A??CA??@A??@A??@A??@A??CA??AA??@A??CA??@A??CA??@A??@A??A'); yourself); yourself]! !

!DataSetBuilder methodsFor:'accessing'!

columns
    "returns list of columns"

    ^columns
!

columns:aListOfColumns fromView:aColumnView
    "setup columns from a column view"

    |list|

    columnView := aColumnView.
    columns    := OrderedCollection new.
    list       := self seqList.
    hasChanged := false.

    list removeAll.

    aListOfColumns size ~~ 0 
    ifTrue:
    [
        aListOfColumns do:
        [:aColumn|
            columns add: aColumn copy.
            aColumn rendererType == #rowSelector 
                ifFalse:[list add: aColumn label]
                ifTrue: [list add:'Row Selector']
        ]
    ]
!

rowClassName

    ^(Smalltalk resolveName:className inClass:self class) notNil ifTrue:[className] ifFalse:[nil]
!

rowClassName:aClassName

    |cls|

    superclassName := nil.

    (className := aClassName) notNil 
    ifTrue:
    [
        (cls := self resolveClassNamed) notNil 
            ifTrue: [superclassName := cls superclass name asString] 
            ifFalse:[superclassName := 'Object']
    ]

! !

!DataSetBuilder methodsFor:'aspects'!

aspectFor:aKey
    "returns aspect for a key or nil"

    ^aspects at:aKey ifAbsent:[super aspectFor:aKey]


!

columnIsNotEditing
    "returns a boolean value holder which is set to true if column is not editing"

    ^builder valueAspectFor:#columnIsNotEditing initialValue: true



!

editorTypeList
    "generate list of supported editor types"

    |list|

    (list := builder bindingAt:#editorTypeList) isNil 
    ifTrue:
    [
        list := OrderedCollection new.
        DataSetColumnSpec slices do:
        [:aSlice||type|
            type := aSlice at:1.
            (list includes:type) ifFalse:[list add:type]
        ].
        builder aspectAt:#editorTypeList put:list
    ].
    ^list
!

isColumnSelected
    "returns a boolean value holder which is set to true if something is modified
     and not accepted"

    ^builder valueAspectFor:#isColumnSelected initialValue: false



!

modifiedChannel
    "returns a boolean value holder which is set to true if something is modified
     and not accepted"

    ^builder booleanValueAspectFor:#modifiedChannel



!

rendererTypeList
    "generate list of supported renderer types"

    |list|

    (list := builder bindingAt:#rendererTypeList) isNil 
    ifTrue:
    [
        list := OrderedCollection new.
        DataSetColumnSpec slices do:
        [:aSlice||type|
            type := aSlice at:2.
            (list includes:type) ifFalse:[list add:type]
        ].
        builder aspectAt:#rendererTypeList put:list
    ].
    ^list
!

selectedColumnModel
    "returns a value holder which keeps selected column"

    |holder|

    (holder := builder bindingAt:#selectedColumnModel) isNil ifTrue:[
        holder := AspectAdaptor new subject:self; forAspect:#selectedColumnIndex.
        builder aspectAt:#selectedColumnModel put:holder.
    ].
    ^ holder
!

seqList

    |list|

    (list := builder bindingAt:#seqList) isNil ifTrue:[
        builder aspectAt:#seqList put:(list :=  List new).
    ].
    ^ list
!

specChannel

    |holder|

    (holder := builder bindingAt:#specChannel) isNil ifTrue:[
        builder aspectAt:#specChannel put:(holder :=  ValueHolder new).
    ].
    ^ holder
!

style

    ^self aspectFor:#labelFont
!

tabList

    ^self class slices collect:[:aSlice|aSlice first]

!

tabModel
    "returns a value holder which keeps the index of the current selected tab or 0"

    |holder|

    (holder := builder bindingAt:#tabModel) isNil ifTrue:[
        holder := AspectAdaptor new subject:self; forAspect:#tabSelectionIndex.
        builder aspectAt:#tabModel put:holder.
    ].
    ^ holder
! !

!DataSetBuilder methodsFor:'change & update'!

update:something with:aParameter from:someObject
    "one of my aspects has changed; update modified channel"

    hasChanged
    ifFalse:
    [
        self valueOfEnablingCommitButtons value: true.
        self columnIsNotEditing value: false
    ]
! !

!DataSetBuilder methodsFor:'code generation'!

compile:aCode forClass:aClass inCategory:aCategory
    "compile method for class in a category"

    ByteCodeCompiler compile:aCode withCRs forClass:aClass inCategory:aCategory
!

generateBackgroundSelectorIn:aClass
    "generate code for #backgroundSelector"

    |sel catg code bCode|

    catg := 'accessing look' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "specific background color for a cell"\'
            , '\'
            .

    columns do:
    [:aColumn|
        ((sel := aColumn backgroundSelector) notNil and:[(aClass implements:sel) not]) 
        ifTrue:
        [
            bCode := sel asString, code, '    ^nil'.
            self compile:bCode forClass:aClass inCategory:catg
        ]
    ]


!

generateChoicesIn:aClass
    "generate code for #choices"

    |sel catg code|

    catg := 'accessing menu' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "get choices for visual editor; (a list of labels)\'
            , '\'
            , '    ^nil'
            .

    columns do:
    [:aColumn|
        (aColumn canSelect
        and:[aColumn rendererType ~~ #rowSelector
        and:[(sel := aColumn choices) notNil
        and:[(aClass implements:sel) not]]]) 
        ifTrue:
        [
            self compile:(sel asString, code) forClass:aClass inCategory:catg
        ]
    ]
!

generateDoubleClickSelectorIn:aClass
    "generate code for #foregroundSelector"

    |sel catg code bCode|

    catg := 'accessing action' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "specific selector to be called on double click"\'
            , '\'
            .

    columns do:
    [:aColumn|
        ((sel := aColumn doubleClickedSelector) notNil 
        and:[(aClass implements:sel) not]) 
        ifTrue:
        [
            bCode := sel asString, code.
            self compile:bCode forClass:aClass inCategory:catg
        ]
    ]


!

generateForegroundSelectorIn:aClass
    "generate code for #foregroundSelector
    "
    |sel catg code bCode|

    catg := 'accessing look' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "specific foreground color for a cell"\'
            , '\'
            .

    columns do:
    [:aColumn|
        ((sel := aColumn foregroundSelector) notNil 
        and:[(aClass implements:sel) not]) 
        ifTrue:
        [
            bCode := sel asString, code, '    ^nil'.
            self compile:bCode forClass:aClass inCategory:catg
        ]
    ]


!

generateMenuIn:aClass
    "generate code for #menu"

    |sel catg code|

    catg := 'accessing menu' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "get middleButton menu for selected cell in column"\'
            , '\'
            , '    ^nil'
            .

    columns do:
    [:aColumn|
        (aColumn canSelect
        and:[(sel := aColumn menu) notNil
        and:[(aClass implements:sel) not]]) 
        ifTrue:
        [
            self compile:(sel asString, code) forClass:aClass inCategory:catg
        ]
    ]
!

generatePrintSelectorIn:aClass
    "generate code for #printSelector"

    |sel catg code|

    catg := 'accessing' asSymbol.
    code :=   'aGC\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "get drawable image or text on a gc"\'
            , '\'
            , '    ^nil'
            .

    columns do:
    [:aColumn|
        (aColumn rendererType ~~ #rowSelector
        and:[(sel := aColumn printSelector) notNil
        and:[(aClass implements:sel) not]]) 
        ifTrue:
        [
            self compile:(sel asString, code) forClass:aClass inCategory:catg
        ]
    ]
!

generateReadSelectorIn:aClass
    "generate code for #readSelector"

    |sel catg code bCode|

    catg := 'accessing' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "get value"\'
            , '\'
            .

    columns do:
    [:aColumn|
        (aColumn rendererType ~~ #rowSelector 
        and:[(sel := aColumn readSelector) notNil
        and:[(aClass implements:sel) not]]) 
        ifTrue:
        [
            (aColumn printSelector isNil or:[aColumn canSelect]) 
            ifTrue:
            [
                sel numArgs == 0 
                    ifTrue: [bCode := sel asString, code] 
                    ifFalse:[bCode := sel asString, 'anIndex\', code].
                aColumn rendererType == #CheckToggle 
                    ifFalse:[bCode := bCode, '    ^nil'] 
                    ifTrue: [bCode := bCode, '    ^true']. 
                self compile:bCode forClass:aClass inCategory:catg
            ]
        ]
    ]
!

generateSelectSelectorIn:aClass
    "generate code for #selectSelector
    "
    |sel catg code bCode|

    catg := 'accessing selection' asSymbol.
    code :=   '\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "can select cell in column"\'
            , '\'
            .

    columns do:
    [:aColumn|
        (aColumn rendererType ~~ #rowSelector 
         and:[(sel := aColumn selectSelector) notNil
         and:[(aClass implements:sel) not]]) 
         ifTrue:
         [
            aColumn canSelect 
            ifTrue:
            [
                bCode := sel asString, code, '    ^true'.
                self compile:bCode forClass:aClass inCategory:catg
            ]
        ]
    ]
!

generateWriteSelectorIn:aClass
    "generate code for #writeSelector"

    |sel catg code bCode sz|

    catg := 'accessing' asSymbol.
    code :=   'aValue\'
            , '    "automatically generated by DataSetBuilder ..."\'
            , '\'
            , '    "set value"\'
            .

    columns do:
    [:aColumn|
        ((sel := aColumn writeSelector) notNil
         and:[aColumn canSelect
         and:[(aClass implements:sel) not]]) 
        ifTrue:
        [
            sel numArgs == 1 
            ifTrue:
            [
                bCode := sel asString
            ] 
            ifFalse:
            [
                sz := sel indexOf:$:.
                bCode := sel copyTo:sz.
                bCode := bCode, 'anIndex ', (sel copyFrom:sz + 1)
            ].
            self compile:(bCode, code) forClass:aClass inCategory:catg
        ]
    ]
! !

!DataSetBuilder methodsFor:'initialization'!

initialize
    "setup aspects used by column description specifications"

    |holder|

    super initialize.
    selectedColumnIndex := 0.
    tabSelectionIndex   := 0.
    columns := OrderedCollection new.
    aspects := IdentityDictionary new.
    hasChanged := false.

    #(
        label
        canSelect
        choices
        editorType
        formatString
        labelIsImage
        size
        type
        width
        minWidth
        height
        menu
        foregroundSelector
        backgroundSelector
        doubleClickedSelector
        selectSelector
        printSelector
        readSelector
        writeSelector
        rendererType
        showColSeparator
        showRowSeparator
        backgroundColor
        foregroundColor
        labelForegroundColor
        labelBackgroundColor
        labelFont
        labelActionSelector
        labelActionArgument
        labelAlignment
     ) do:[:aKey|
        aspects at:aKey put:(holder := ValueHolder new).
        holder addDependent:self
    ]

! !

!DataSetBuilder methodsFor:'private'!

checkMenuItemModified
    "check column modification"

    self valueOfEnablingCommitButtons value
    ifTrue:
    [
        ((YesNoBox title:'Column was modified!!\Save it?\' withCRs)        
            noText:'No';
            yesText:'Yes';
            showAtPointer;
            accepted) ifFalse: [self valueOfEnablingCommitButtons value: false. ^true].
        self accept
    ].
    ^true

!

resolveClassNamed
    "returns current class or nil"

    ^Smalltalk resolveName:className inClass:self class.

!

updateColumnView
    "update column view from column descriptions"

    columnView notNil ifTrue:[columnView columnDescriptors:columns]
!

updateInputFields
    "reload item value into input fields"

    |column|

    (column := self selectedColumn) isNil 
    ifTrue:
    [
        self tabModel value:0.
    ] 
    ifFalse:
    [
        aspects keysAndValuesDo:[:aKey :aModel|aModel value:(column perform:aKey)].
        tabSelectionIndex == 0 ifTrue:[self tabModel value:1]
    ]
! !

!DataSetBuilder methodsFor:'queries'!

hasChanged
    "returns true if changes are done to the original column description"

    ^hasChanged
! !

!DataSetBuilder methodsFor:'selection'!

selectedColumn
    "returns selected column or nil"

    ^selectedColumnIndex == 0 
        ifFalse:[columns at:selectedColumnIndex]
        ifTrue: [nil]
!

selectedColumnIndex
    "returns selected column index or 0"

    ^selectedColumnIndex
!

selectedColumnIndex:something
    "change selected column and update specifications"

    something == selectedColumnIndex 
    ifFalse:
    [
        selectedColumnIndex := something ? 0.
        self isColumnSelected value: true
    ]

!

tabSelectionIndex
    "returns selected tab index or 0"

    ^tabSelectionIndex
!

tabSelectionIndex:something
    "change selected tab and set corresponding specification"

    |specSelector|

    something == tabSelectionIndex ifTrue:[^self].
    self selectedColumn isNil 
    ifTrue:
    [
        tabSelectionIndex == 0 ifTrue:[^self].
        tabSelectionIndex := 0
    ] 
    ifFalse:
    [
        (tabSelectionIndex := something) ~~ 0 
            ifTrue: [specSelector := (self class slices at:tabSelectionIndex) last]
    ].
    self specChannel value:specSelector


! !

!DataSetBuilder methodsFor:'startup / release'!

closeRequest
    "close request"

    self checkMenuItemModified ifTrue: [super closeRequest]
!

postBuildWith:builder

    super postBuildWith:builder.

    (builder componentAt: #columnView) 
        selectConditionBlock: [:i|self checkMenuItemModified];
        action: [:i|self cancel];
        selection: 1



! !

!DataSetBuilder methodsFor:'user actions'!

accept
    "accept changes made"

    |column type|

    self valueOfEnablingCommitButtons value == false ifTrue: [^self].
    hasChanged := true.

    (column := self selectedColumn) isNil ifTrue: [^self cancel].

    type := (aspects at:#rendererType) value.

    type == #rowSelector 
    ifTrue:
    [
        #(label width minWidth editorType choices readSelector writeSelector printSelector
          formatString type size height canSelect selectSelector) do:[:aKey|(aspects at:aKey) value:nil]
    ].
        
    aspects keysAndValuesDo:[:aKey :aModel| column perform:(aKey , ':') asSymbol with: aModel value].
    self seqList at:selectedColumnIndex put: (aspects at:#label) value.
    self updateColumnView.
    self cancel
!

cancel
    "remove all changes and reload selected column values"

    |column|

    self updateInputFields.
    self valueOfEnablingCommitButtons value:false.
    self columnIsNotEditing value: true.
!

doBrowseClass
    "browse class of columns spec"

    |cls|

    (cls := self resolveClassNamed) notNil 
        ifTrue: [SystemBrowser openInClass:cls] 
        ifFalse:[self information:'No class defined!!']



!

doCopyColumn
    "copy selected column to the clipboard"

    |idx|

    (idx := selectedColumnIndex) ~~ 0 
    ifTrue:
    [
        self clipboard: (columns at: idx) deepCopy
    ]
!

doCreateColumn
    "create a new column after selected column or at left (nothing selected)"

    |label list|

    list := self seqList.
    label := 'Column ', (list size + 1) printString.
    columns add:(DataSetColumnSpec label:label selector:nil) afterIndex:selectedColumnIndex.
    self seqList add:label afterIndex:selectedColumnIndex.
    hasChanged := true.
    self valueOfEnablingCommitButtons value ifFalse:[self selectedColumnModel value:selectedColumnIndex + 1].
    self cancel

!

doCutColumn
    "remove selected column and put it to the clipboard"

    |idx|

    ((idx := selectedColumnIndex) ~~ 0 and: [self checkMenuItemModified]) 
    ifTrue:
    [
        self selectedColumnModel value:0.
        self clipboard: (columns at: idx).
        columns removeIndex:idx.
        self seqList removeIndex:idx.
        columns size > 0 ifTrue: [self selectedColumnModel value: ((idx - 1) max: 1)].
        self updateColumnView.
        self updateInputFields.
        columns isEmpty ifTrue: [self isColumnSelected value: false].
        self cancel.
        hasChanged := true.
    ]
!

doDefineClass
    "launch a dialog to define class and superclass"

    |aspects cls oldClass oldSuper|

    aspects  := IdentityDictionary new.
    oldClass := className.
    oldSuper := superclassName.

    [true] 
    whileTrue:
    [
        className notNil 
        ifTrue:
        [
            (cls := self resolveClassNamed) notNil 
            ifTrue:
            [
                superclassName := cls superclass name asString
            ].
            aspects at:#classNameChannel put:className asValue
        ] 
        ifFalse:
        [
            aspects at:#classNameChannel put:'DSVRow' asValue
        ].

        superclassName notNil 
            ifTrue: [aspects at:#superclassNameChannel put:superclassName asValue] 
            ifFalse:[aspects at:#superclassNameChannel put:'Object' asValue].

        (self openDialogInterface:#defineClassNameSpec withBindings:aspects) 
        ifFalse:
        [
            className := oldClass.
            superclassName := oldSuper.
            ^self
        ].
        className      := ((aspects at:#classNameChannel) value)      withoutSeparators.
        superclassName := ((aspects at:#superclassNameChannel) value) withoutSeparators.

        className size == 0 
        ifTrue:
        [
            className := nil.
            self information:'no valid className'
        ] 
        ifFalse: 
        [
            cls := self resolveClassNamed.

            cls notNil ifTrue:[cls := cls superclass name asString].

            superclassName size == 0 
            ifTrue:
            [        
                cls notNil ifTrue:[
                    superclassName := cls
                ] ifFalse:[
                    superclassName := 'Object'
                ].
                self information: 'set superclassName'
            ] 
            ifFalse:
            [
                (cls isNil or:[superclassName = cls]) ifTrue:[hasChanged := true. ^self].
                self information:('A global named ' , className , ' exists,\' ,
                                  'but is not a subclass of ' , superclassName, '.\\' ,
                                  'Check and try again if that is not what you want.') withCRs.

                superclassName := cls
            ]
        ]
    ]
!

doGenerateCode
    "generate code for column values"

    |cls superclass|

    className isNil ifTrue:[^self information:'No class defined!!'].
    cls := self resolveClassNamed.

    cls isNil 
    ifTrue:
    [
        superclass := Smalltalk resolveName:superclassName inClass:self class.

        superclass isNil ifTrue:[^self information:'No superclass defined!!'].
        (self confirm:'create ' , className , ' ?') ifFalse:[^self].
        cls := superclass subclass:className asSymbol
                     instanceVariableNames:''
                     classVariableNames:''
                     poolDictionaries:''
                     category:'Applications'.
    ].

    self generateChoicesIn:cls.
    self generateMenuIn:cls.
    self generatePrintSelectorIn:cls.
    self generateReadSelectorIn:cls.
    self generateBackgroundSelectorIn:cls.
    self generateForegroundSelectorIn:cls.
    self generateSelectSelectorIn:cls.
    self generateWriteSelectorIn:cls.
    self generateDoubleClickSelectorIn:cls.
!

doMoveColumn:upOrDown
    "move selected column up or down"

    |idx list label col size|

    (idx := selectedColumnIndex) == 0 ifTrue:[^self].
    list := self seqList.
    size := list size.

    size == 1 ifTrue:[^self].
    hasChanged := true.
    selectedColumnIndex := 0.
    label := list at:idx.
    col   := columns at:idx.
    list    removeIndex:idx.
    columns removeIndex:idx.

    upOrDown == #up 
    ifTrue:
    [
        idx == 1 ifTrue:[idx := size]
                ifFalse:[idx := idx - 1]
    ] 
    ifFalse:
    [
        idx == size ifTrue:[idx := 1]
                   ifFalse:[idx := idx + 1]
    ].
    columns add:col   beforeIndex:idx.
    list    add:label beforeIndex:idx.  
    self selectedColumnModel value:idx.
    self updateColumnView.
!

doPasteColumn
    "paste clipboard copy column after selected column or at left (nothing selected)"

    |label list|

    list := self seqList.
    label := self class clipboard label.
    columns add: self class clipboard deepCopy afterIndex:selectedColumnIndex.
    self seqList add: label afterIndex:selectedColumnIndex.
    hasChanged := true.

    self valueOfEnablingCommitButtons value ifFalse:[self selectedColumnModel value:selectedColumnIndex + 1].
    self updateColumnView.
    self updateInputFields.
! !

!DataSetBuilder class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
